'use strict'


	function Logger(options) {
		this.$Logger_options = options
		this.$Logger_count = 0
		this.$Logger_stack = {}
	}

	Logger.prototype.log=function(message, func) {
		var result

		if (process.env.NODE_ENV !== 'production' && this.$Logger_options.debug) {
			this.$Logger_start(message)
			result = func()
			this.$Logger_stop(message)
			return result
		}
		return func()
	};

	Logger.prototype.$Logger_start=function(message) {
		var indentation = this.$Logger_indent()
		var now = new Date()

		this.$Logger_stack[message] = now

		console.log(("[" + now.toISOString() + "] " + indentation + "Starting " + message + "..."))
	};

	Logger.prototype.$Logger_stop=function(message) {
		var indentation = this.$Logger_unindent()
		var now = new Date()
		var elapsed = now - this.$Logger_stack[message]

		console.log(("[" + now.toISOString() + "] " + indentation + "Finished " + message + " after " + elapsed + " ms"))
	};

	Logger.prototype.$Logger_indent=function() {
		return Array(++this.$Logger_count).join('  ')
	};

	Logger.prototype.$Logger_unindent=function() {
		return Array(this.$Logger_count--).join('  ')
	};


module.exports = Logger