'use strict';

var generateMask = require('./utils').generateMask;
var mod$3 = require('./options');var BLUEPRINT = mod$3.BLUEPRINT;var PROVIDER = mod$3.PROVIDER;
var mod$4 = require('./constants');var CONTAINER_ALIAS = mod$4.CONTAINER_ALIAS;var CONTEXT_ALIAS = mod$4.CONTEXT_ALIAS;

var ALIAS_IDX = 0
var VALUE_IDX = 1
var TYPE_IDX = 2
var DEPS_IDX = 3

function createChildContainerFactory(conf) {
	return function (container) {
		return container.createChild(conf)
	}
}

function createExporter(containerFactory, exportAlias) {
	return function (container) {
		return containerFactory(container).get(exportAlias)
	}
}

module.exports = function createContext(contribute) {

	var pending = []
	var context = {

		map: function(alias)  {
			context.flush()
			pending.push(alias)

			return {
				to: function(value)  {

					pending.push(value)

					return {
						as: function()  {var flags=Array.prototype.slice.call(arguments,0);
							var mask = generateMask(flags)

							if (mask === BLUEPRINT) {
								// test if VALUE is a function
								flags = [PROVIDER]
								pending[VALUE_IDX] = createChildContainerFactory(pending[VALUE_IDX])
								pending.push(generateMask(flags))
								pending.push([CONTAINER_ALIAS])
								
								return {
									exports: function(alias)  {
										pending[VALUE_IDX] = createExporter(pending[VALUE_IDX], alias)
										return {
											map: context.map
										}
									},
									map: context.map
								}
							}

							pending.push(mask)
							
							return {
								map: context.map,
								
								injecting: function()  {var deps=Array.prototype.slice.call(arguments,0);
									pending.push(deps)

									return {
										map: context.map
									}
								}
							}
						}
					}
				}
			}
		},

		flush: function()  {
			var deps = pending[DEPS_IDX] || []

			if (pending.length > 2) {
				contribute(pending[ALIAS_IDX], pending[VALUE_IDX], pending[TYPE_IDX], deps)
				pending = []
			}
		}
	}

	return context
}