'use strict'

var mod$8 = require('./utils');
var leftCurryTwice = mod$8.leftCurryTwice;
var identity = mod$8.identity;
var compose = mod$8.compose;
var partial = mod$8.partial;

var resolveDeps = mod$8.resolveDeps;
var invoke = mod$8.invoke;

var instanciate = mod$8.instanciate;
var singletonify = mod$8.singletonify;

var generateMask = mod$8.generateMask;


var mod$9 = require('./options');
var VALUE = mod$9.VALUE;
var PROVIDER = mod$9.PROVIDER;
var CONSTRUCTOR = mod$9.CONSTRUCTOR;
var SINGLETON = mod$9.SINGLETON;
var FUNCTION = mod$9.FUNCTION;
var INSTANCE = mod$9.INSTANCE;
var PERSISTENT = mod$9.PERSISTENT;
var TRANSIENT = mod$9.TRANSIENT;
var LAZY = mod$9.LAZY;
var EAGER = mod$9.EAGER;


var resolvers = {}

resolvers[ generateMask([VALUE]) ] = compose(leftCurryTwice, resolveDeps)(identity)
resolvers[ generateMask([FUNCTION]) ] = compose(leftCurryTwice, resolveDeps)(partial)
resolvers[ generateMask([CONSTRUCTOR]) ] = compose(leftCurryTwice, resolveDeps)(instanciate)
resolvers[ generateMask([PROVIDER]) ] = compose(leftCurryTwice, resolveDeps)(invoke)

resolvers[ generateMask([TRANSIENT, SINGLETON, PROVIDER]) ] = singletonify(invoke)
resolvers[ generateMask([TRANSIENT, CONSTRUCTOR, SINGLETON]) ] = singletonify(instanciate)

resolvers[ generateMask([LAZY, SINGLETON, PROVIDER]) ] = singletonify(invoke, true)
resolvers[ generateMask([LAZY, SINGLETON, CONSTRUCTOR]) ] = singletonify(instanciate, true)

resolvers[ generateMask([EAGER, SINGLETON, PROVIDER])] = singletonify(invoke, true)
resolvers[ generateMask([EAGER, SINGLETON, CONSTRUCTOR]) ] = singletonify(instanciate, true)

// aliases
resolvers[ generateMask([INSTANCE]) ] = resolvers[ generateMask([VALUE]) ]

// backward compatibility
resolvers[ generateMask([PERSISTENT, SINGLETON, PROVIDER]) ] = resolvers[ generateMask([LAZY, SINGLETON, PROVIDER]) ]
resolvers[ generateMask([PERSISTENT, CONSTRUCTOR, SINGLETON]) ] = resolvers[ generateMask([LAZY, CONSTRUCTOR, SINGLETON]) ]

module.exports = resolvers