'use strict'

var instanciate = require('./instanciate');
var singletonify = require('./singletonify');
var mod$16 = require('./options');var EAGER = mod$16.EAGER;var SINGLETON = mod$16.SINGLETON;var PROVIDER = mod$16.PROVIDER;var CONSTRUCTOR = mod$16.CONSTRUCTOR;

var EAGER_SINGLETON_PROVIDER = generateMask([EAGER, SINGLETON, PROVIDER])
var EAGER_SINGLETON_CONSTRUCTOR = generateMask([EAGER, SINGLETON, CONSTRUCTOR])

function identity(value) { return value } module.exports.identity = identity;

function leftCurryTwice(fn) {
	return function firstCurry() {var firstArgs=Array.prototype.slice.call(arguments,0);
		return function secondCurry() {var secondArgs=Array.prototype.slice.call(arguments,0);
			return fn.apply(null, firstArgs.concat(secondArgs))
		}
	}
} module.exports.leftCurryTwice = leftCurryTwice;

function compose() {var funcs=Array.prototype.slice.call(arguments,0);
	return function () {var args=Array.prototype.slice.call(arguments,0);

		var i

		for (i = funcs.length - 1; i >= 0; i--) {
			args = [funcs[i].apply(this, args)]
		}
		return args[0]
	}
} module.exports.compose = compose;

function resolveDeps(fn) {
	return function (value, resolve, release, signal) {
		return fn.call(this, value, resolve())
	}
} module.exports.resolveDeps = resolveDeps;

function invoke(fn, deps) {
	return fn.apply(null, deps)
} module.exports.invoke = invoke;

function partial(func, boundArgs) {
	return function () {var args=Array.prototype.slice.call(arguments,0);
		return func.apply(this, boundArgs.concat(args))
	}
} module.exports.partial = partial;

function generateMask(flags) {
	return flags.reduce(function(prev, curr)  {return prev | curr;}, 0)
} module.exports.generateMask = generateMask;

function isEagerSingleton(type) {
	return [EAGER_SINGLETON_PROVIDER, EAGER_SINGLETON_CONSTRUCTOR].indexOf(type) > -1
} module.exports.isEagerSingleton = isEagerSingleton;

function noop() {} module.exports.noop = noop;

module.exports.instanciate = instanciate;module.exports.singletonify = singletonify;